<?php 

if(!defined('ABSPATH')) exit;

class Psb_Ajax {
	
	public static function init() {
		add_action('wp_ajax_psb_ajax', array(__CLASS__, 'do_ajax'));
	}

	public static function do_ajax() {
		check_ajax_referer('psb_nonce', 'psb_token');
		if(isset($_POST['psb_action'])) {
			$action = $_POST['psb_action'];

			if($action == 'createLabel') {
			    update_option('psb_slocker', serialize(array($_POST['psb_smode'], array($_POST['psb_slocker'], $_POST['psb_slocker_d1'], $_POST['psb_slocker_d2']))));
			    if($_POST['psb_smode'] == 3) $slocker = $_POST['psb_slocker'];
			    else $slocker = '';
				$resp = Psb_Api::createLabel($_POST['psb_id_order'], $_POST['psb_service'], $_POST['psb_cod'], $_POST['psb_carrier'], $_POST['psb_kwota'], $_POST['psb_uwagi'], $_POST['psb_ubezp'], $_POST['psb_waga'], $_POST['psb_dlug'], $_POST['psb_szer'], $_POST['psb_wys'], $_POST['psb_nst'], $_POST['psb_locker'], $slocker);
				if($resp === false) {
					echo json_encode(array(
						'error' => reset(Psb_Api::$errors)
					));
					wp_die();
				}
				
				$id_patron = $resp[0];
				$tracking = $resp[1];
				echo json_encode(array(
					'error' => false,
					'id_patron' => (int)$id_patron,
					'tracking' => $tracking
				));
				wp_die();
			}

			if($action == 'getPdf') {
				header_remove();
				$pdf_file_contents = Psb_Api::getLabelPdfApi($_POST['psb_id_order']);

				if($pdf_file_contents === false) {
					header("HTTP/1.1 500 Internal Server Error");
					wp_die();
				}
			
				header('Content-type: application/pdf');
				header('Content-Disposition: attachment; filename="patron_label_'. sprintf("%07d", $_POST['psb_id_order']) .'.pdf"');
				echo $pdf_file_contents;
				wp_die();
			}
				
			if($action == 'getServs') {
				$data = json_decode(stripslashes($_POST['psb_data']), true);
				$resp = Psb_Api::getServs($_POST['psb_user'], $_POST['psb_pass'], $_POST['psb_url'], $data);
				if($resp === false) {
					echo json_encode(array(
						'error' => reset(Psb_Api::$errors)
					));
					wp_die();
				}
			
				echo json_encode(array(
					'error' => false,
					'data' => $resp
				));
				wp_die();
			}

		}
	
	}
	
}

?>