<?php 

if(!defined('ABSPATH')) exit;

class Psb_Api {
	
	static $errors = array();
	static $paczkomatowe = array(95, 123);
	//	static $zabronione = array(95, 123, 173);
	static $zabronione = array(173);
	const psb_trackUrl = 'https://patronservice.pl/@';
	const psb_testurl = 'http://dev.api.patronbroker.opennet.pl/api.asmx?WSDL';
	const psb_produrl = 'http://api.patronbroker.opennet.pl/api.asmx?WSDL';
	
	static function createLabel($id_order, $metoda, $iscod, $ca, $kwota, $i_uwg, $i_ubezp, $i_waga, $i_dlug, $i_szer, $i_wys, $i_nst, $locker, $slocker) {
//	    $slocker = 'KRA013';
//	    $locker = 'KRA013';
		try {
			if(!extension_loaded('soap')) {
				self::$errors[] = 'Brak modułu PHP-soap';
				return false;
			}
			$order = wc_get_order($id_order);
			if($i_ubezp != 'undefined' && $i_ubezp != '' && !is_numeric($i_ubezp)) {
				self::$errors[] = 'Ubezpieczenie - błędny format liczby';
				return false;
			}
			if($i_waga != 'undefined' && $i_waga != '' && !is_numeric($i_waga)) {
				self::$errors[] = 'Waga - błędny format liczby';
				return false;
			}
			if($i_wys != 'undefined' && $i_wys != '' && !is_numeric($i_wys)) {
				self::$errors[] = 'Wysokość - błędny format liczby';
				return false;
			}
			if($i_dlug != 'undefined' && $i_dlug != '' && !is_numeric($i_dlug)) {
				self::$errors[] = 'Długość - błędny format liczby';
				return false;
			}
			if($i_szer != 'undefined' && $i_szer != '' && !is_numeric($i_szer)) {
				self::$errors[] = 'Szerokość - błędny format liczby';
				return false;
			}
			if(!in_array($metoda, self::$paczkomatowe))	$type = 'Package';
			else $type = self::getInpostType($i_wys, $i_dlug, $i_szer);
			if($$type) {
			    self::$errors[] = 'Przekroczone dozwolone wymiary gabarytów paczkomatu.';
			    return false;
			}

			$params = array(
				"token" => array(
					"UserName" => get_option('psb_api_login'),
					"Password" => get_option('psb_api_pass')
				),
				"createShipmentRequest" => array(
					"ServiceId" => $metoda,
					"ShipFrom" => array(
					    "PointId" => $slocker,
						"ClientTaxId" => '',
						"Name" => get_option('psb_sender_name'),
						"Address" => get_option('psb_sender_adr'),
						"City" => get_option('psb_sender_city'),
						"PostCode" => trim(get_option('psb_sender_code')),
						"CountryCode" => 'PL',
						"Person" => get_option('psb_sender_person'),
						"Contact" => get_option('psb_sender_phone'),
						"Email" => get_option('psb_sender_email'),
						"IsPrivatePerson" => false
					),
					"ShipTo" => array(
					    "PointId" => $locker,
						"ClientTaxId" => '',
						"Name" => $order->get_shipping_company() == '' ? $order->get_shipping_first_name() . ' ' . $order->get_shipping_last_name() : $order->get_shipping_company(),
						"Address" => $order->get_shipping_address_1() . ($order->get_shipping_address_2() ? ' ' . $order->get_shipping_address_2() : ''),
						"City" => $order->get_shipping_city(),
						"PostCode" => trim($order->get_shipping_postcode()),
						"CountryCode" => $order->get_shipping_country(),
						"Person" => $order->get_shipping_first_name() . ' ' . $order->get_shipping_last_name(),
						"Contact" => trim($order->get_billing_phone()),
						"Email" => $order->get_billing_email(),
						"IsPrivatePerson" => ($order->get_shipping_company() == '')
					),
					"Parcels" => array(
						"Parcel" => array(
							"Type" => $type,
							"Weight" => $i_waga,
							"D" => $i_dlug,
							"W" => $i_wys,
							"S" => $i_szer,
							"IsNST" => ($i_nst == 1)
						)
					),
					"COD" => array(
						"Amount" => $kwota,
						"RetAccountNo" => 0
					),
					"InsuranceAmount" => $kwota != 0 ? $kwota : $ubez,
					"MPK" => "",
					"ContentDescription" => $i_uwg,
					"rabateCoupon" => 0,
					"LabelFormat" => 'PDF',
					"AdditionalServices" => array()
				)
			);
			if(in_array($metoda, self::$paczkomatowe)) {
			    unset($params['createShipmentRequest']['Parcels']['Parcel']['D']);
			    unset($params['createShipmentRequest']['Parcels']['Parcel']['W']);
			    unset($params['createShipmentRequest']['Parcels']['Parcel']['S']);
			}
			//if(get_option('psb_mail')) $params['ShipmentRequest']['AdditionalServices']['AdditionalService'][] = array('Code' => 'EMAIL');
			//if(get_option('psb_sms')) $params['ShipmentRequest']['AdditionalServices']['AdditionalService'][] = array('Code' => 'SMS');
	
			$response = self::call("CreateShipment", $params);
	
			if(isset($response->CreateShipmentResult) && (!isset($response->CreateShipmentResult->responseDescription) || ($response->CreateShipmentResult->responseDescription != 'Success'))) {
				error_log('CreateShipment resp ' . print_r($response, true));
				self::$errors[] = "Błąd API: " . '[' . $response->CreateShipmentResult->responseCode . '] ' . $response->CreateShipmentResult->responseDescription;
				return false;
			}
			if(isset($response->CreateShipmentResult->ParcelData->Label->ParcelID)) {
				$api_id = $response->CreateShipmentResult->ParcelData->Label->ParcelID;
				$response->CreateShipmentResult->ParcelData->Label->MimeData = "[" . strlen($response->CreateShipmentResult->ParcelData->Label->MimeData) . "]";
			}
			elseif(isset($response->CreateShipmentResult->PackageNo)) { 
				$api_id = $response->CreateShipmentResult->PackageNo;
			}
			else {
				error_log('CreateShipment resp ' . print_r($response, true));
				self::$errors[] = 'Nierozpoznana odpowiedź API';
				return false;
			}
			error_log('CreateShipment resp ' . print_r($response, true));
			
			update_post_meta($id_order, '_psb_data', array('api_id' => $api_id, 'service' => $metoda, 'cod' => $iscod, 'carrier' => $ca));
			$resp = array($api_id, self::genTrackLink($api_id));
			return $resp;
		} catch(Exception $e) {
			self::$errors[] = $e->getMessage();
			return false;
		}
	}
	
	static function getLabelPdfApi($id_order) {
		$meta = get_post_meta($id_order, '_psb_data', true);
		$carr = $meta['carrier'];
		$api_id = $meta['api_id'];

		$params = array(
			"token" => array(
				"UserName" => get_option('psb_api_login'),
				"Password" => get_option('psb_api_pass')
			),
			"request" => array(
				'RequestedLabels' => array(
					'PackagesByCarrier' => array(
						'Carrier' => $carr,
						"PackageNo" =>  array(
							"string" => $api_id
						)
					)
				),
				'MimeFormat' => 'PDF'
			)
		);

		$response = self::call("GetLabel", $params, $order);
		
		if(!isset($response->GetLabelResult->responseDescription) || ($response->GetLabelResult->responseDescription != 'Success')) {
			error_log('GetLabel resp ' . print_r($response, true));
			return false;
		}
		$shippingLabelContent = $response->GetLabelResult->LabelData->Label->MimeData;
		$response->GetLabelResult->LabelData->Label->MimeData = "[" . strlen($shippingLabelContent) . "]";
		error_log('GetLabel resp ' . print_r($response, true));
		return $shippingLabelContent;
	}

	static function getServs($user, $pass, $url, $data) {
		$params = array(
			"token" => array(
				"UserName" =>  $user,
				"Password" =>  $pass
			)
		);
		$ret = self::call('GetServicesInfo', $params, $url);
		error_log('GetServicesInfo resp ' . print_r($ret, true));
		if($ret === false) {
			return false;
		}
	
		if(!isset($ret->GetServicesInfoResult->responseDescription) || ($ret->GetServicesInfoResult->responseDescription != 'Success')) {
			self::$errors[] = 'Błąd API: ' . $ret->GetServicesInfoResult->responseDescription;
			return false;
		}
		if(is_object($ret->GetServicesInfoResult->Services->ServiceInfo)) $ret->GetServicesInfoResult->Services->ServiceInfo = array($ret->GetServicesInfoResult->Services->ServiceInfo);
		usort($ret->GetServicesInfoResult->Services->ServiceInfo, array("Psb_Api", "objcmp"));
		
		$zerowe = array();
		$tmp = array();
		foreach($data as $k => $a) {
			$t = explode(',', $k);
			if($a['del']) $tmp[$t[0]][$t[1]] = $a['price'];
		}
		foreach($tmp as $k => $a)
			if(($a[0] == 0) && ($a[1] == 0))
				$zerowe[] = $k;
		$arr = array();
		foreach($ret->GetServicesInfoResult->Services->ServiceInfo as $si) {
			if(in_array($si->ID, self::$zabronione)) continue;
			$a = array(
				'name' => $si->Name,
				'price' => 0,
				'carrier' => $si->Carrier,
				'del' => 0
			);
			$arr[$si->ID . ',0'] = $a;
			$a['name'] = $si->Name . ' (pobranie)';
			$arr[$si->ID . ',1'] = $a;
		}
		foreach($data as $k => $a) {
			$t = explode(',', $k);
			if(in_array($t[0], $zerowe)) continue;
			if(!isset($arr[$k])) $a['del'] = 1;
			else $a['del'] = 0;
			$a['name'] = $arr[$k]['name'];
			$arr[$k] = $a;
		}
		update_option('psb_api_login', $user);
		update_option('psb_api_pass', $pass);
		update_option('psb_api_url', $url);
		
		return $arr;
	}

	static function call($meth, $params, $url = '') {
		if(!$url) $url = get_option('psb_api_url');
		error_log("URL=$url");
		try {
			error_log($meth . ' req ' . print_r($params, true));
			$client = new SoapClient($url);
				
			$response = $client->__soapCall($meth, array($params));
		} catch (Exception $e) {
			self::$errors[] = $e->getMessage();
			return false;
		}
		return $response;
	}

	static function getInpostType($w, $d, $s) {
	    if(($s > 38) || ($d > 64) || ($w > 41)) return false;
	    if($w <= 8) return 'ParcelLockerA';
	    else if($w <= 19) return 'ParcelLockerB';
	    else return 'ParcelLockerC';
	}

	static function objcmp($a, $b) {
		return $a->ID <=> $b->ID;
	}
	
	static function genTrackLink($track) {
		$ret = '<a target="_blank" class="_blank" href="' . self::psb_trackUrl . '">@</a>';
		$ret = str_replace('@', $track, $ret);
		return $ret;
	}
	
}

?>